/* $Id: GuiPlayer.java,v 1.6 2007/11/28 17:49:43 ekstrand Exp $ */

package csci1902.hw6.ui;

import csci1902.hw6.game.BadMoveException;
import csci1902.hw6.game.Board;
import csci1902.hw6.game.Player;
import csci1902.hw6.game.PlayerID;

/**
 * Player implementation which allows a human to play via the GUI.
 *
 * @author Michael Ekstrand <ekstrand@cs.umn.edu>
 */
class GuiPlayer extends Player implements CellClickListener {

    /**
     * Construct a new GUI player.
     */
    public GuiPlayer(PlayerID player) {
        super(player);
    }

    /**
     * Respond to a cell being clicked.  This forwards the cell clicked on to
     * the game as a move, but only if it is the player's turn.
     */
    public void cellClicked(CellClickEvent event) {
        if (isActive()) {
            Board b = game.getBoard();
            try {
                new Board(b, id, event.getPosition());
            } catch (BadMoveException e) {
                return;
            }
            notifyMove(event.getPosition());
        }
    }

}
